#include "letters.h"
#include <stdint.h>

const byte interruptPin = 3;
const uint8_t addr_offset[LED_NR] = {0, 8, 16, 24, 32, 40, 48, 56};
volatile uint8_t const *letter_addr = another_game;
volatile byte states[LED_NR] = {LOW, LOW, LOW, LOW, LOW, LOW, LOW, LOW}; 
volatile byte state = LOW;
volatile uint8_t counter = 0;
volatile uint8_t change_game = 0;
volatile bool reset_letter = false;
// functia ce realizeaza jocul de lumini
void game_on(){
  uint8_t i = 0;
  // daca nu s-a terminat jocul, se seteaza
  // led-urile in functie de matricea corespunzatoare
  // jocului
  if(reset_letter == false) {
    for (i = 0; i < 8; i++) {
      if ( *(letter_addr + addr_offset[i] + counter)) {
        states[i] = HIGH;  
      } else {
        states[i] = LOW;  
      }  
    }
   }
    counter++;
    if (counter >= 8) {
      // daca s-a terminat jocul, se sting toate led-urile
      reset_letter = true;
      if (counter >= 9) {
          counter = 0;
            for (i = 5; i <= 12; i++) {
              digitalWrite(i, LOW);
            }
            // se alege alt joc in functie de iteratia
            // la care s-a ajuns
          reset_letter = false;
          change_game++;
          if (change_game == 1) {
            letter_addr = hello;
          } else if (change_game == 2) {
            letter_addr = world;
          } else if (change_game == 3) {
            letter_addr = M_letter;
          } else if (change_game == 4) {
            letter_addr = I_letter;
          } else if (change_game == 5) {
            letter_addr = R_letter;
          } else if (change_game == 6) {
            letter_addr = U_letter;
          } else {
            letter_addr = another_game;
          }
      }
    }
}

void setup() {
  // led-urile
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(12, OUTPUT);
  pinMode(LED_BUILTIN, OUTPUT);
  // rezistenta de pull-up a senzorului HALL
  pinMode(interruptPin, INPUT_PULLUP);
  // se aplica intreruperea pentru senzor
  attachInterrupt(digitalPinToInterrupt(interruptPin), game_on, CHANGE);
}

void loop() {
  uint8_t i = 0;
  for (i = 5; i <= 12 ;i++) {
    digitalWrite(i, states[i-5]);
  }
}
