#ifndef __LETTERS__
#define __LETTERS__
#include <stdint.h>

#define LETTER_SIZE 64U
#define MAX_LETTERS 4U
#define LED_NR 		8U

const uint8_t M_letter[LETTER_SIZE] = {1,0,0,0,0,0,0,1,
									                     1,1,0,0,0,0,1,1,
                                       1,0,1,0,0,1,0,1,
                                       1,0,0,1,1,0,0,1,
                                       1,0,0,1,1,0,0,1,
                                       1,0,0,0,0,0,0,1,
                                       1,0,0,0,0,0,0,1,
                                       1,0,0,0,0,0,0,1};
								 
uint8_t I_letter[LETTER_SIZE] = {0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0,
								                 0,0,0,1,1,0,0,0};

uint8_t R_letter[LETTER_SIZE] = {1,1,1,1,0,1,0,0,
								                1,0,0,0,0,1,0,0,
								                1,0,0,0,0,1,0,0,
								                1,1,1,1,1,1,0,0,
								                1,0,1,0,0,0,0,0,
								                1,0,0,1,0,0,0,0,
								                1,0,0,0,1,0,0,0,
								                1,0,0,0,0,1,0,0};

uint8_t U_letter[LETTER_SIZE] = {1,0,0,0,0,0,0,1,
								                 1,0,0,0,0,0,0,1,
								                 1,0,0,0,0,0,0,1,
								                 1,0,0,0,0,0,0,1,
								                 1,0,0,0,0,0,0,1,
								                 1,0,0,0,0,0,0,1,
								                 0,1,0,0,0,0,1,0,
								                 0,0,1,1,1,1,0,0};	


uint8_t another_game[LETTER_SIZE] = {1,0,0,0,1,0,0,0,
                             0,1,0,0,0,1,0,0,
                             0,0,1,0,1,0,0,1,
                             1,0,0,1,1,0,0,0,
                             0,1,0,0,1,0,0,0,
                             0,1,0,0,0,1,1,1,
                             1,0,1,0,0,0,1,0,
                             0,0,0,0,0,0,0,1};  		

uint8_t game[LETTER_SIZE] = {1,0,0,0,0,0,0,0,
                             0,1,0,0,0,0,0,0,
                             0,0,1,0,0,0,0,0,
                             0,0,0,1,0,0,0,0,
                             0,0,0,0,1,0,0,0,
                             0,0,0,0,0,1,0,0,
                             0,0,0,0,0,0,1,0,
                             0,0,0,0,0,0,0,1}; 

uint8_t hello[LETTER_SIZE] = {1,1,1,1,1,1,1,1,
                             1,1,1,1,1,1,1,0,
                             1,1,1,1,1,1,0,0,
                             1,1,1,1,1,0,0,0,
                             1,1,1,1,0,0,0,0,
                             1,1,1,0,0,0,0,0,
                             1,1,0,0,0,0,0,0,
                             1,0,0,0,0,0,0,0}; 

uint8_t world[LETTER_SIZE] = {0,0,0,0,0,0,0,1,
                             0,0,0,0,0,0,1,1,
                             0,0,0,0,0,1,1,1,
                             0,0,0,0,1,1,1,1,
                             0,0,0,1,1,1,1,1,
                             0,0,1,1,1,1,1,1,
                             0,1,1,1,1,1,1,1,
                             1,1,1,1,1,1,1,1}; 

#endif
